#
# [ICQ Commander] - Control your bots right on ICQ
# Originally Posted: Thu Oct 18, 2007 08:10pm (c)v0idhq
# UPDATE 19.10.2007 (c) v0idhq
#
# in config.txt file add:
#    ICQ_uin 00000             # - bot uin
#    ICQ_pass mY_s1cret_Pa$$   # - bot icq password
#    ICQ_start 1               # - If you wish to receive the message when the bot has entered online
#    ICQ_admin 123456          # - admin icq
#
package icqCommander;
use Encode;
use strict;
use Time::HiRes qw(time usleep);
my $icq;
my $MaxLen= 1024;
my $icq_uin;
my $icq_passw;
my $start_send=0;
my $start_icq=0;
my $We_Are_Online;

use Plugins;
use Log qw(message);
use Commands;
use Globals;
use Network;
use Utils;
no Network::Send;

my $ai_hook;
Plugins::register('icqCommander', 'ICQ Commander', \&event_unload, \&event_reload);
$ai_hook = Plugins::addHook('AI_pre', \&init);


sub init {

if (!$start_icq) {
&mainAI;
}else{
    $icq->Execute_Once();
    $icq->Connected() or &event_unload;
 }       
}

sub event_unload {
        Plugins::delHook('AI_pre', $ai_hook);
        message "ICQ Commander plugin unloaded\n";
}

sub event_reload {
        &event_unload;
}

sub mainAI{
### USER CONFIGURATION ###
if ($Globals::config{'ICQ_uin'}) {
    $icq_uin=$Globals::config{'ICQ_uin'};
    $icq_passw=$Globals::config{'ICQ_pass'};
   
require 'ICQ2000_Easy.pm';
$icq = Net::ICQ2000_Easy->new($icq_uin, $icq_passw,"1");
#make ICQ2000_Easy automaticly acknowledge offline messages (otherwise u have to do it manualy
#       Or you'll get the same messages again and again every time u login (using normal connection, not min..)
$icq->Auto_Ack_Offline_Messages(1);
$icq->Set_Debugging(0); # 0 = non, 1 = ICQ2000_Easy only, 2 = ICQ2000.pm only, 3 = all.
$icq->Add_Hook("Srv_Mes_Received", \&RecMessage);
$icq->Add_Hook("Srv_GSC_User_Info", \&GSC_User_Info);
$icq->Add_Error_Hook(\&General_Error_Notice);
$start_icq=1;
}
### USER CONFIGURATION ###
}


sub GSC_User_Info {
 my($Object, $details) = @_;
    #this gives use info about our online presence (eg our status..)
 if ($Globals::config{'ICQ_admin'}) {
    if ($Globals::config{'ICQ_start'}){
        &Send_Normal_Message; #or whatever u want the script to do..
        $start_send=1;
    }
    
    }   
    print "We're now [online]\n";
    
}
sub Send_Normal_Message {
 my($Object, $details) = @_;
if ($icq_uin) { 
if($details->{Text}){
#coming soon .....
}else{
if( $Globals::config{'ICQ_admin'}){
    $details->{Text} = "I`m online\nWAZAAAAAAAAP! ;)";
    $details->{Target_UIN} = $Globals::config{'ICQ_admin'}; #The UIN of the message recipient..
    $icq->Send_Command("Cmd_Send_Message", $details);
    }
    }
    }
}


sub RecMessage {
 my($Object, $details) = @_;
       my $ircchat;
       $ircchat= encode('utf8', $details->{text});
      #Example!!!!!!!! 
      #use Encode;
      #my $cp1251 = '!'; #    windows-1251 
      #my $utf8 = encode('utf8', $cp1251); #   UTF-8
      #print $utf8."\n";
      #my $win_ru = decode('utf8', $utf8); #  
      #print $win_ru;
        my $ircmsgnick;
        ($ircmsgnick) = $details->{Sender};
my($ircadmincmd) = split(/\s/,$ircchat);
   if ($details->{MessageType} eq "Normal"){
      if($details->{Sender} eq $Globals::config{'ICQ_admin'}){
             if ($details->{text} eq "!help"){
                #coming soon....
                #&Send_Normal_Message;
              }else{
                  my $Log_Hook_ID = Log::addHook(\&RedirectToICQ,$ircmsgnick);
                 Commands::run($ircchat) || main::parseCommand($ircchat);
                 Log::delHook($Log_Hook_ID);
               }
            }else{
            #coming soon ....
             }  
       }  
}

sub RedirectToICQ {
        my $type = shift;               # "message"
        my $domain = shift;             # "MyDomain"
        my $level = shift;              # 2
        my $globalVerbosity = shift;    # 1 (equal to $config{'verbose'})
        my $message = shift;            # "Hello World"
        my $user_data = shift;          # "my_user_data"
        my @message;
        my $details;
        #print "lvl - ".$level."\n";
        #print "message - ".$message."\n";
        #print "user_data - ".$user_data."\n";
        $details->{Target_UIN} = $user_data;
        open my $fh, ">my_icq_log.txt";
            binmode $fh, ":encoding(cp1251)";
            print $fh $message;
            close $fh;
         open IN, 'my_icq_log.txt';
            my $content = join '', <IN>;
            close IN;
            
        my $ms= length($content);
        my $i=0;
        while($i<$ms){
        my $tosend=substr($content, $i, $MaxLen);

            
            #print $content;
            $details->{Text} = $tosend;
           $icq->Send_Command("Cmd_Send_Message", $details);


           

        $i=$i+$MaxLen;
        }
        return 0;
}

return 1;